<template>
    <v-container class="editor pa-0">
        <v-row>
            <v-col>
                <editor-menu-bar :editor="editor" v-slot="{ commands, isActive, getMarkAttrs }">

                    <v-btn-toggle class="flex-wrap" v-model="toggleNone" dark>
                        <v-btn
                            @click="commands.bold"
                        >
                            <v-icon>mdi-format-bold</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.italic"
                        >
                            <v-icon>mdi-format-italic</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.strike"
                        >
                            <v-icon>mdi-format-strikethrough</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.underline"
                        >
                            <v-icon>mdi-format-underline</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.paragraph"
                        >
                            <v-icon>mdi-format-paragraph</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.heading({ level: 1 })"
                        >
                            <v-icon>mdi-format-header-1</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.heading({ level: 2 })"
                        >
                            <v-icon>mdi-format-header-2</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.heading({ level: 3 })"
                        >
                            <v-icon>mdi-format-header-3</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.bullet_list"
                        >
                            <v-icon>mdi-format-list-bulleted</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.ordered_list"
                        >
                            <v-icon>mdi-format-list-numbered</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.blockquote"
                        >
                            <v-icon>mdi-format-quote-close</v-icon>
                        </v-btn>

                        <v-btn
                            @click="showImagePrompt(commands.image)"
                        >
                            <v-icon>mdi-image</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.horizontal_rule"
                        >
                            <v-icon>mdi-minus</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.createTable({rowsCount: 3, colsCount: 3, withHeaderRow: false })"
                        >
                            <v-icon>mdi-table</v-icon>
                        </v-btn>

                        <template v-if="isActive.table()">
                            <v-btn @click="commands.deleteTable">
                                 <v-icon>mdi-table-cancel</v-icon>
                             </v-btn>

                            <v-btn @click="commands.addColumnBefore">
                                <v-icon>mdi-table-column-plus-before</v-icon>
                            </v-btn>

                            <v-btn @click="commands.addColumnAfter">
                                <v-icon>mdi-table-column-plus-after</v-icon>
                            </v-btn>

                            <v-btn @click="commands.deleteColumn">
                                <v-icon>mdi-table-column-remove</v-icon>
                            </v-btn>

                            <v-btn @click="commands.addRowBefore">
                                <v-icon>mdi-table-row-plus-before</v-icon>
                            </v-btn>

                            <v-btn @click="commands.addRowAfter">
                                <v-icon>mdi-table-row-plus-after</v-icon>
                            </v-btn>

                            <v-btn @click="commands.deleteRow">
                                <v-icon>mdi-table-row-remove</v-icon>
                            </v-btn>

                            <v-btn @click="commands.toggleCellMerge">
                                <v-icon>mdi-table-merge-cells</v-icon>
                            </v-btn>
                        </template>

                        <v-btn
                            @click="commands.undo"
                        >
                            <v-icon>mdi-undo</v-icon>
                        </v-btn>

                        <v-btn
                            @click="commands.redo"
                        >
                            <v-icon>mdi-redo</v-icon>
                        </v-btn>

                    </v-btn-toggle>
                </editor-menu-bar>

                <editor-content class="editor__content" :class="errors.length ? 'error--state' : ''" :editor="editor" />

                <div class="error-messages">
                    <div class="v-messages v-messages__message error--text">
                        <div v-if="errors">
                            {{ errors instanceof Array ? errors[0] : errors }}
                        </div>
                    </div>
                </div>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import { Editor, EditorContent, EditorMenuBar } from 'tiptap'
    import {
        Blockquote,
        CodeBlock,
        HardBreak,
        Heading,
        HorizontalRule,
        OrderedList,
        BulletList,
        ListItem,
        TodoItem,
        TodoList,
        Bold,
        Code,
        Table,
        TableHeader,
        TableCell,
        TableRow,
        Italic,
        Link,
        Image,
        Strike,
        Underline,
        History,
    } from 'tiptap-extensions'

    export default {
        name: 'TextEditor',

        props: {
            value: String,
            errors: [String, Array],
        },

        components: {
            EditorMenuBar,
            EditorContent,
        },

        data: () => ({
            toggleNone: null,
            linkUrl: null,
            linkMenuIsActive: false,
            editor: null
        }),

        watch: {
            value (val) {
                this.editor.setContent(val, true, {preserveWhitespace: true});
            }
        },

        mounted() {
            this.editor = new Editor({
                extensions: [
                    new Blockquote(),
                    new BulletList(),
                    new CodeBlock(),
                    new HardBreak(),
                    new Heading({ levels: [1, 2, 3] }),
                    new HorizontalRule(),
                    new ListItem(),
                    new OrderedList(),
                    new TodoItem(),
                    new TodoList(),
                    new Link(),
                    new Bold(),
                    new Code(),
                    new Italic(),
                    new Strike(),
                    new Underline(),
                    new History(),
                    new Table({
                        resizable: true,
                    }),
                    new TableHeader(),
                    new TableCell(),
                    new TableRow(),
                ],
                content: this.value,
                onUpdate: ({ getHTML }) => {
                    this.$emit('input', getHTML())
                },
            });

            this.editor.setContent(this.value, false, {preserveWhitespace: true});
        },

        beforeDestroy() {
            this.editor.destroy()
        },

        methods: {
            showImagePrompt(command) {
                const src = prompt('Enter the url of your image here')
                if (src !== null) {
                    command({ src })
                }
            },
        }
    }
</script>
